bootcamp-research/_bryce/W9D5/music_app/config/routes.rb
Rails.application.routes.draw do
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root to: redirect("/bands")

  resource :session, only: [:new, :create, :destroy]

  resources :users, only: [:new, :create, :show]
  resources :bands do
    resources :albums, only: [:new]
  end
  resources :albums, only: [:show, :create, :edit, :update, :destroy] do
    resources :tracks, only: [:new]
  end
  resources :tracks, only: [:show, :create, :edit, :update, :destroy]
end

bootcamp-research/_bryce/W9D5/music_app/app/models/band.rb
# == Schema Information
#
# Table name: bands
#
#  id         :bigint(8)        not null, primary key
#  name       :string           not null
#  created_at :datetime         not null
#  updated_at :datetime         not null
#

class Band < ApplicationRecord
  validates :name, presence: true

  has_many :albums,
    dependent: :destroy
  has_many :tracks,
    through: :albums,
    source: :tracks
end

bootcamp-research/_bryce/W9D5/music_app/app/controllers/bands_controller.rb
class BandsController < ApplicationController
  before_action :ensure_logged_in, except: [:index]

  def index
    @bands = Band.all
    render :index
  end

  def create
    @band = Band.new(band_params)
    if @band.save
      redirect_to band_url(@band)
    else
      flash.now[:errors] = @band.errors.full_messages
      render :new
    end
  end

  def new
    @band = Band.new
    render :new
  end

  def edit
    @band = Band.find_by(id: params[:id])
    if @band
      render :edit
    else
      flash[:errors] = "Invalid band"
      redirect_to bands_url
    end
  end

  def show
    @band = Band.includes(:albums).find_by(id: params[:id])
    if @band
      render :show
    else
      flash[:errors] = "Invalid band"
      redirect_to bands_url
    end
  end

  def update
    @band = Band.find(params[:id])
    if @band.update(band_params)
      render :show
    else
      flash.now[:errors] = @band.errors.full_messages
      render :edit
    end
  end

  def destroy
    band = Band.find(params[:id])
    band.destroy
    redirect_to bands_url
  end

  private

  def band_params
    params.require(:band).permit(:name)
  end
end

bootcamp-research/_bryce/W9D5/music_app/app/views/bands/edit.html.erb
<h3>Edit <%=@band.name%></h3>

<form action="<%=band_url(@band)%>" method="POST">
    <input type="hidden" name="_method" value="PATCH">
    <input type="hidden" name="authenticity_token" value="<%= form_authenticity_token %>">
    <label for="name">Name</label>
    <input type="text" name="band[name]" id="name" value="<%= @band.name %>">
    <input type="submit" value="Submit">
</form>

bootcamp-research/_bryce/W9D5/music_app/app/views/bands/index.html.erb
<h3>Bands</h3>

<section class="box">
    <% @bands.each do |band| %>
        <a class="item" href=<%=band_url(band)%>><%= band.name %></a>
    <% end %>
</section>

<%= content_for :footer do %>
    <h5>Links</h5>
    <a class="item" href=<%=new_band_url%>>Add a Band!</a>
<% end %>

bootcamp-research/_bryce/W9D5/music_app/app/views/bands/new.html.erb
<h3>New Band!</h3>

<form action="<%=bands_url%>" method="POST">
    <input type="hidden" name="authenticity_token" value="<%= form_authenticity_token %>">
    <label for="name">Name</label>
    <input type="text" name="band[name]" id="name">
    <input type="submit" value="Submit">
</form>

bootcamp-research/_bryce/W9D5/music_app/app/views/bands/show.html.erb
<h3><%=@band.name%></h3>

<h5>Albums</h5>
<% if @band.albums.empty? %>
    <p>This band has no albums... yet!</p>
<% else %>
    <section class="box">
    <% @band.albums.each do |album| %>
        <a class="item" href=<%=album_url(album)%>><%= album.title %></a>
    <% end %>
    </section>
<% end %>

<%= content_for :footer do %>
    <h5>Links</h5>
    <section class="box">
        <a class="item" href=<%=new_band_album_url(@band)%>>New Album</a>
        <a class="item" href=<%=edit_band_url%>>Edit Band</a>
        <form class="item" action="<%= band_url(@band) %>" method="POST">
            <input type="hidden" name="_method" value="DELETE">
            <input type="hidden" name="authenticity_token" value="<%= form_authenticity_token %>">
            <input type="submit" value="Destroy Band">
        </form>
        <a class="item" href=<%=bands_url%>>All Bands</a>
    </section>
<% end %>